;##################################################################
; PICKER CONTROL
;##################################################################

#include "DropDownPicker.h"

;DEBUGLIB equ C:\Programming\RadASM\GoAsm\lib\Debug.lib
;DEBUGEXE equ "C:\Programming\RadAsm\GoAsm\lib\dbgwin.exe"

;#include "C:\Programming\RadASM\GoAsm\inc\debug.a"
;DBGWIN_DEBUG_ON = 1 // use this to enable Spy/StopSpy/DbgDump and TrapException
;DBGWIN_SHOWONLYERRORS = 1 // setting this to 1 will suppress PrintError if no error exists 

// Constants

GWL_PICKER_HBUTTON equ 0
GWL_PICKER_HDRPDWN equ 4
GWL_PICKER_BSTATUS equ 8
GWL_PICKER_HNDFONT equ 12
GWL_PICKER_MASKCLR equ 16
GWL_PICKER_N_ITEMS equ 20
GWL_PICKER_N_WIDTH equ 24
GWL_PICKER_IMGLIST equ 28
GWL_PICKER_BASE_ID equ 32
GWL_PICKER_PTRTEXT equ 36

GWL_DRPDWN_HPARENT equ 0
GWL_DRPDWN_HPKRBMP equ 4
GWL_DRPDWN_CUR_SEL equ 8
GWL_DRPDWN_SRCT_TL equ 12 ; left/top (HIGHWORD/LOWORD) 
GWL_DRPDWN_SRCT_BR equ 16 ; right/ bottom (HIGHWORD/LOWORD) 
GWL_DRPDWN_SEL_CLR equ 20

PM_ADDIMAGE equ WM_USER + 50h
PM_REMOVEIMAGE equ WM_USER + 51h
PM_REPLACEIMAGE equ WM_USER + 52h
PM_GETIMGLIST equ WM_USER + 53h
PM_SETSTRINGRES equ WM_USER + 54h
PM_SETWIDTH equ WM_USER + 55h
PM_SETMASKCOLOR equ WM_USER + 56h
PM_SETBASEID equ WM_USER + 57h
PM_SETTEXT equ WM_USER + 58h
PM_GETTEXT equ WM_USER + 59h
PM_SETFONT equ WM_USER + 60h
PM_SETSELCLR equ WM_USER + 61h

DATA SECTION
	hInstance	DD		?

CODE SECTION

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke PickerInit
	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL hCntrl :D
	LOCAL hImg		:D
	LOCAL hmask		:D
	LOCAL outtext[128]:B

	mov eax,[uMsg]
	cmp eax,WM_INITDIALOG
	jne >>.WMCOMMAND
	
		invoke GetDlgItem,[hwnd],1001
		mov [hCntrl],eax
		invoke SendMessage,[hCntrl],PM_SETMASKCOLOR,0,0
		invoke SendMessage,[hCntrl],PM_SETBASEID,2000,0

		invoke LoadImage,[hInstance],206,IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS
		mov [hImg],eax

		invoke SendMessage,[hCntrl],PM_ADDIMAGE,eax,IMAGE_BITMAP
		invoke DeleteObject,[hImg]
		invoke SendMessage,[hCntrl],PM_SETWIDTH,5,0
		jmp >.EXIT

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >.WMCLOSE
		invoke GetDlgItem,[hwnd],1001
		mov [hCntrl],eax
		
		invoke wsprintf,offset outtext,"id = %u",[wParam]
		add esp,12
		invoke SendMessage,[hCntrl],PM_SETTEXT,offset outtext,0

		jmp >.EXIT

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

PickerInit FRAME
	LOCAL wcx		:WNDCLASSEX
	LOCAL hInst		:D
	LOCAL hCursor	:D

	invoke LoadCursor,NULL,IDC_ARROW
	mov [wcx.hCursor],eax

	invoke GetModuleHandle,0
	mov [wcx.hInstance],eax

	mov D[wcx.cbSize],SIZEOF WNDCLASSEX
	mov D[wcx.style], CS_HREDRAW + CS_VREDRAW
	mov D[wcx.lpszClassName],OFFSET UDC_PickerClass
	mov D[wcx.lpfnWndProc],OFFSET PickerProc
	mov D[wcx.cbClsExtra],0
	mov D[wcx.cbWndExtra],40
	mov D[wcx.lpszMenuName],NULL
	mov D[wcx.hIcon],NULL
	mov D[wcx.hIconSm],NULL
	mov D[wcx.hbrBackground],COLOR_WINDOW+1

	invoke RegisterClassEx,ADDR wcx

	mov	D[wcx.cbSize],sizeof WNDCLASSEX
	mov	D[wcx.style], CS_HREDRAW or CS_VREDRAW
	mov	D[wcx.lpszClassName],offset Picker_dropdown
	mov	D[wcx.lpfnWndProc],offset Picker_dropdown_proc
	mov	D[wcx.cbClsExtra],NULL
	mov	D[wcx.cbWndExtra],40
	mov	D[wcx.lpszMenuName],NULL
	mov	D[wcx.hIcon],NULL
	mov	D[wcx.hIconSm],NULL
	mov D[wcx.hbrBackground],COLOR_BTNFACE+1

	invoke RegisterClassEx,addr wcx

	RET

	UDC_PickerClass:	DB "UDC_PICKER_CLASS",0
	Picker_dropdown:	DB "Picker_dropdown",0

ENDF

PickerProc FRAME hwnd, uMsg, wParam, lParam
	uses ebx,esi,edi
	LOCAL ps		:PAINTSTRUCT
	LOCAL prect		:RECT
	LOCAL brect		:RECT
	LOCAL pt		:POINT
	LOCAL himl		:D
	LOCAL hImg		:D
	LOCAL hmask		:D
	LOCAL pszText	:D

	cmp D[uMsg], WM_CREATE
	jne >>.WM_COMMAND

		// Get the size of the control
		invoke GetClientRect,[hwnd],offset prect

		// The button should be square using the height of the client area as one side
		mov esi,[prect.bottom]
		mov eax,[prect.right]
		mov [brect.right],eax
		sub eax,esi
		mov [brect.left],eax
		mov D[brect.top],0
		mov [brect.bottom],esi

		invoke GetModuleHandle,NULL
		invoke CreateWindowEx,NULL,"BUTTON","",BS_PUSHLIKE + BS_AUTOCHECKBOX + BS_BITMAP + WS_CHILD + WS_VISIBLE,[brect.left],0,esi,esi,[hwnd],9999,eax,0
		mov edi,eax		
		invoke SetWindowLong,[hwnd],GWL_PICKER_HBUTTON,eax

		invoke GetModuleHandle,NULL
		invoke LoadImage,eax,134,IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS
		mov ebx,eax

		invoke SetWindowLong,edi,GWL_USERDATA,ebx
		invoke SendMessage,edi,BM_SETIMAGE,IMAGE_BITMAP,ebx

		invoke SetWindowLong,[hwnd],GWL_PICKER_BSTATUS,FALSE

		// initially there are no items in the imagelist
		invoke SetWindowLong,[hwnd],GWL_PICKER_N_ITEMS,0

		// set the width in icons of the control default is 4
		invoke SetWindowLong,[hwnd],GWL_PICKER_N_WIDTH,4

		// By default the mask color is black (0.0.0)
		invoke SetWindowLong,[hwnd],GWL_PICKER_MASKCLR,0

		// Images for the control are stored in an image list
		// in order to allow the original image to be destroyed.
		invoke ImageList_Create,16,16,ILC_COLOR32 + ILC_MASK,64,64
		mov [himl],eax

		invoke SetWindowLong,[hwnd],GWL_PICKER_IMGLIST,[himl]

		invoke GlobalAlloc,GPTR,256
		invoke SetWindowLong,[hwnd],GWL_PICKER_PTRTEXT,eax
		invoke GetStockObject,DEFAULT_GUI_FONT
		invoke SetWindowLong,[hwnd],GWL_PICKER_HNDFONT,eax

		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg], WM_COMMAND
	jne >>.WM_PAINT
		movzx edx,W[wParam]
		cmp edx,9999
		jne >>.EXIT
			// The pushed/unpushed state is automatically toggled however we will do
			// it manually in order to dismiss the drop down menu
			invoke GetWindowLong,[hwnd],GWL_PICKER_BSTATUS
			test eax,eax
			jz >.SET2PUSHED
			invoke GetWindowLong,[hwnd],GWL_PICKER_HBUTTON
			invoke SendMessage,eax,BM_SETCHECK,BST_UNCHECKED,0
			invoke SetWindowLong,[hwnd],GWL_PICKER_BSTATUS,FALSE
			// Dismiss the select window if it is showing
			invoke GetWindowLong,[hwnd],GWL_PICKER_HDRPDWN
			test eax,eax
			jz >>.WM_COMMAND_DONE
			invoke SendMessage,eax,WM_CLOSE,0,0
			invoke SetWindowLong,[hwnd],GWL_PICKER_HDRPDWN,NULL
			invoke SetCapture,NULL
			jmp >>.WM_COMMAND_DONE

			.SET2PUSHED
			// Set the flag needed to reset the button when a selection is made
			invoke GetWindowLong,[hwnd],GWL_PICKER_HBUTTON
			invoke SendMessage,eax,BM_SETCHECK,BST_CHECKED,0
			invoke SetWindowLong,[hwnd],GWL_PICKER_BSTATUS,TRUE
			// display the select window
			// Get the position of the control
			invoke GetWindowRect,[hwnd],offset prect

			invoke GetWindowLong,[hwnd],GWL_PICKER_N_ITEMS
			mov ebx,eax

			// Calculate the width
			invoke GetWindowLong,[hwnd],GWL_PICKER_N_WIDTH
			mov edx,eax
			mov ecx,eax
			shl eax,4 // 16 pixels per item
			shl edx,1 // 2 pixels of separation between them
			add eax,edx // Total width
			mov edi,eax
			mov eax,[prect.right]
			sub eax, [prect.left]

			// calculate the desired height ECX holds the width EBX the number of items
			mov eax,ebx
			test eax,eax
			jnz >.1
				add eax,1
				jmp >.2
			.1
			xor edx,edx
			div ecx
			test edx,edx
			jz >.2
				add eax,1
			.2
			mov ecx,eax
			shl eax,4
			shl ecx,2
			add eax,ecx
			mov esi,eax

			// Add 3 pixels for the horizontal borders
			add edi,3

			// In order that the drop down can extend beyond the client area of the parent window
			// We will make it a child of the desktop and give it top most style. This is essentially
			// what Windows does when it shows a menu. To make sure it is displayed properly even
			// on slow machines, it is created without WS_VISIBLE and displayed only when its
			// set up is complete. The instance handle has to be set to this process, since this may
			// end up as a library function, we will explicitly get the instance handle to avoid dependncies.

			invoke GetModuleHandle,NULL
			mov ebx,eax

			invoke GetDesktopWindow
			
			// Align the right edge so that it aligns with the right edge of the button
			mov ecx,[prect.right]
			sub ecx,edi
			
			invoke CreateWindowEx,WS_EX_TOOLWINDOW,offset Picker_dropdown,"",WS_DLGFRAME + WS_CHILD ,ecx,[prect.bottom],edi,esi,eax,1000,ebx,[hwnd]
			push eax
			invoke SetWindowLong,[hwnd],GWL_PICKER_HDRPDWN,eax
			pop eax
			invoke SetWindowPos,eax,HWND_TOPMOST,0,0,0,0,SWP_NOOWNERZORDER + SWP_NOSIZE + SWP_NOMOVE + SWP_SHOWWINDOW

			// Capture the mouse to be able to dismiss the window when necessary
			invoke SetCapture,[hwnd]

			.WM_COMMAND_DONE
			xor eax,eax
			ret

	.WM_PAINT
	cmp D[uMsg],WM_PAINT
	jne >>.WM_LBUTTONDOWN
		invoke BeginPaint,[hwnd],offset ps
		invoke GetWindowLong,[hwnd],GWL_PICKER_HNDFONT
		invoke SelectObject,[ps.hdc],eax
		mov ebx,eax
		invoke SetTextColor,[ps.hdc],0
		invoke GetClientRect,[hwnd],offset prect
		invoke GetWindowLong,[hwnd],GWL_PICKER_HBUTTON
		invoke GetClientRect,eax,offset brect
		mov eax,[prect.right]
		sub eax,[brect.right]
		mov [prect.right],eax
		add D[prect.left],2 // indent
		invoke GetWindowLong,[hwnd],GWL_PICKER_PTRTEXT
		mov [pszText],eax
		invoke DrawText,[ps.hdc],[pszText],-1,offset prect,DT_LEFT + DT_VCENTER + DT_SINGLELINE
		invoke SelectObject,[ps.hdc],ebx
		invoke EndPaint,[hwnd],offset ps
		xor eax,eax
		ret

	.WM_LBUTTONDOWN
	cmp D[uMsg], WM_LBUTTONDOWN
	jne >>.PM_SETTEXT
		// Get the drop down window handle and compare it to the window at the cursor position
		// If they are equal the user has selected an item from the drop down, if not the
		// drop down window should be dismissed, this is consistent with the UI used for menus.
		invoke GetWindowLong,[hwnd],GWL_PICKER_HDRPDWN
		mov ebx,eax

		invoke GetCursorPos,offset pt
		invoke WindowFromPoint,[pt.x],[pt.y]
		cmp ebx,eax
		je >>.DROPDOWNSEL

			invoke GetWindowLong,[hwnd],GWL_PICKER_HBUTTON
			invoke SendMessage,eax,BM_SETCHECK,BST_UNCHECKED,0
			invoke SetWindowLong,[hwnd],GWL_PICKER_BSTATUS,FALSE

			test ebx,ebx
			jz >>.EXIT
			invoke SendMessage,ebx,WM_CLOSE,0,0
			invoke SetWindowLong,[hwnd],GWL_PICKER_HDRPDWN,NULL
			invoke SetCapture,NULL
			jmp >>.EXIT

		.DROPDOWNSEL
			invoke ScreenToClient,ebx,offset pt
			mov ecx,18
			mov eax,[pt.x]
			test eax,eax
			js >>.EXIT
			cdq
			div ecx
			mov edi,eax
			mov eax,[pt.y]
			test eax,eax
			js >>.EXIT
			cdq
			div ecx
			mov esi,eax
			// Multiply by the number of images to a row
			invoke GetWindowLong,[hwnd],GWL_PICKER_N_WIDTH
			mul esi
			add edi,eax
			
			invoke GetWindowLong,[hwnd],GWL_PICKER_N_ITEMS
			cmp edi,eax
			jge >>.EXIT
			
			invoke GetWindowLong,[hwnd],GWL_PICKER_BASE_ID
			add edi,eax
			invoke GetParent,[hwnd]
			invoke SendMessage,eax,WM_COMMAND,edi,[hwnd]

			// Close the picker window
			invoke SendMessage,ebx,WM_CLOSE,0,0
			invoke SetWindowLong,[hwnd],GWL_PICKER_HDRPDWN,NULL
			invoke SetWindowLong,[hwnd],GWL_PICKER_BSTATUS,FALSE
			invoke GetWindowLong,[hwnd],GWL_PICKER_HBUTTON
			invoke SendMessage,eax,BM_SETCHECK,BST_UNCHECKED,0
			invoke SetCapture,NULL
			jmp >>.EXIT

	.PM_SETFONT
	cmp D[uMsg],PM_SETFONT
	jne >>.PM_SETTEXT
		invoke SetWindowLong,[hwnd],GWL_PICKER_HNDFONT,eax
		ret

	.PM_SETTEXT
	cmp D[uMsg],PM_SETTEXT
	jne >>.PM_GETTEXT
		invoke GetWindowLong,[hwnd],GWL_PICKER_PTRTEXT
		invoke lstrcpy,eax,[wParam]
		invoke InvalidateRect,[hwnd],NULL,TRUE
		xor eax,eax
		ret

	.PM_GETTEXT
	cmp D[uMsg],PM_GETTEXT
	jne >>.PM_SETWIDTH
		invoke GetWindowLong,[hwnd],GWL_PICKER_PTRTEXT
		invoke lstrcpy,[wParam],eax
		xor eax,eax
		ret

	.PM_SETWIDTH
	cmp D[uMsg],PM_SETWIDTH
	jne >>.PM_SETMASKCOLOR
		invoke SetWindowLong,[hwnd],GWL_PICKER_N_WIDTH,[wParam]
		ret

	.PM_SETMASKCOLOR
	cmp D[uMsg],PM_SETMASKCOLOR
	jne >>.PM_ADDIMAGE
		invoke SetWindowLong,[hwnd],GWL_PICKER_MASKCLR,[wParam]
		ret

	.PM_ADDIMAGE
	cmp D[uMsg],PM_ADDIMAGE
	jne >>.PM_REMOVEIMAGE
		// PM_ADDIMAGE
		// adds an image to the end of the image list
		// wParam = handle of the image
		// lParam = IMAGE_BITMAP / IMAGE_ICON specifies what type of image to add
		invoke GetWindowLong,[hwnd],GWL_PICKER_IMGLIST
		mov ebx, eax

		mov eax,[lParam]
		cmp eax, IMAGE_BITMAP
		je >>.IMAGE_BITMAP
		.IMAGE_ICON
			invoke ImageList_ReplaceIcon, ebx,-1,[wParam]
			push eax
			invoke SetWindowLong,[hwnd],GWL_PICKER_N_ITEMS,eax
			pop eax
			ret
		.IMAGE_BITMAP
			invoke GetWindowLong,[hwnd],GWL_PICKER_MASKCLR
			invoke GenerateMask,[wParam],eax
			mov [hmask],eax
			invoke ImageList_Add,ebx,[wParam],[hmask]
			push eax
			invoke ImageList_GetImageCount,ebx
			invoke SetWindowLong,[hwnd],GWL_PICKER_N_ITEMS,eax
			invoke DeleteObject,[hmask]
			pop eax
			ret

	.PM_REMOVEIMAGE
	cmp D[uMsg],PM_REMOVEIMAGE
	jne >>.PM_GETIMGLIST
		// PM_REMOVEIMAGE
		// removes an image from the image list
		// wParam = index of the image to remove
		invoke GetWindowLong,[hwnd],GWL_PICKER_IMGLIST
		invoke ImageList_Remove,eax,[wParam]
		ret

	.PM_GETIMGLIST
	cmp D[uMsg],PM_GETIMGLIST
	jne >>.PM_SETBASEID
		invoke GetWindowLong,[hwnd],GWL_PICKER_IMGLIST
		ret

	.PM_SETBASEID
	cmp D[uMsg],PM_SETBASEID
	jne >>.WM_MOUSEMOVE
		invoke SetWindowLong,[hwnd],GWL_PICKER_BASE_ID,[wParam]
		ret

	.PM_SETSELCLR
	cmp D[uMsg],PM_SETSELCLR
	jne >>.WM_MOUSEMOVE
		invoke GetWindowLong,[hwnd],GWL_PICKER_HDRPDWN
		invoke SetWindowLong,eax,GWL_DRPDWN_SEL_CLR,[wParam]
		ret

	.WM_MOUSEMOVE
	// Hot tracking of the items
	cmp D[uMsg],WM_MOUSEMOVE
	jne >>.WM_CLOSE
		invoke GetWindowLong,[hwnd],GWL_PICKER_HDRPDWN
		mov ebx,eax
		test eax,eax
		jz >>.EXIT

		invoke GetCursorPos,offset pt
		invoke WindowFromPoint,[pt.x],[pt.y]
		cmp ebx,eax
		jne >>.NOITEM
			// Get the highlighted item if any
			invoke GetWindowLong,ebx,GWL_DRPDWN_CUR_SEL
			test eax,eax
			js >
				invoke GetWindowLong,ebx,GWL_DRPDWN_SRCT_TL
				mov ecx,eax
				shr ecx,16
				mov [prect.left],ecx
				and eax,0FFFFh
				mov [prect.top],eax
				invoke GetWindowLong,ebx,GWL_DRPDWN_SRCT_BR
				mov ecx,eax
				shr ecx,16
				mov [prect.right],ecx
				and eax,0FFFFh
				mov [prect.bottom],eax

				invoke InvalidateRect,ebx,offset prect,TRUE
			:
			// Get the image number
			invoke ScreenToClient,ebx,offset pt
			mov ecx,18
			mov eax,[pt.x]
			test eax,eax
			js >>.EXIT
			cdq
			div ecx
			mov edi,eax
			mov eax,[pt.y]
			test eax,eax
			js >>.EXIT
			cdq
			div ecx
			mov esi,eax
			// Multiply by the number of images to a row
			invoke GetWindowLong,[hwnd],GWL_PICKER_N_WIDTH
			mul esi
			add edi,eax

			invoke GetWindowLong,[hwnd],GWL_PICKER_N_ITEMS
			cmp edi,eax
			jge >>.NOITEM

			// Highlight the image
			invoke SetWindowLong,ebx,GWL_DRPDWN_CUR_SEL,edi
			
			// Set the bounding rectangle
			// Horizontal
			invoke GetWindowLong,[hwnd],GWL_PICKER_N_WIDTH
			mov ecx,eax
			mov eax,edi
			cdq
			div ecx
			mov edi,eax
			mov eax,edx
			shl edx,4 // 16 pixels
			shl eax,1
			add edx,eax
			mov esi,edx

			// Vertical
			mov eax,edi
			sub edi,1
			shl edi,1
			shl eax,4
			add edi,eax
			add edi,2

			// edi = Vertical
			// esi = Horizontal

			mov ecx,esi
			shl ecx,16
			and edi,0FFFFh
			or ecx,edi
			invoke SetWindowLong,ebx,GWL_DRPDWN_SRCT_TL,ecx

			add esi,16
			add edi,16
			
			shl esi,16
			or esi,edi
			invoke SetWindowLong,ebx,GWL_DRPDWN_SRCT_BR,esi

			invoke InvalidateRect,ebx,offset prect,TRUE
			jmp >>.EXIT

			.NOITEM
			invoke SetWindowLong,ebx,GWL_DRPDWN_CUR_SEL,-1

			invoke GetWindowLong,ebx,GWL_DRPDWN_SRCT_TL
			mov ecx,eax
			shr ecx,16
			mov [prect.left],ecx
			and eax,0FFFFh
			mov [prect.top],eax
			invoke GetWindowLong,ebx,GWL_DRPDWN_SRCT_BR
			mov ecx,eax
			shr ecx,16
			mov [prect.right],ecx
			and eax,0FFFFh
			mov [prect.bottom],eax
			invoke InvalidateRect,ebx,offset prect,TRUE
			jmp >>.EXIT

	.WM_CLOSE
	cmp D[uMsg], WM_CLOSE
	jne >>.EXIT
		invoke GetWindowLong,[hwnd],GWL_PICKER_IMGLIST
		invoke ImageList_Destroy,eax
		invoke GetWindowLong,[hwnd],GWL_PICKER_PTRTEXT
		invoke GlobalFree,eax
		// Destroy the bitmap
		invoke GetWindowLong,[hwnd],GWL_PICKER_HBUTTON
		invoke GetWindowLong,eax,GWL_USERDATA
		invoke DeleteObject,eax
		invoke GetWindowLong,[hwnd],GWL_PICKER_HDRPDWN
		test eax,eax
		jz >
		invoke SendMessage,eax,WM_CLOSE,0,0
		:

	.EXIT
	invoke DefWindowProc,[hwnd], [uMsg], [wParam], [lParam]
	RET
ENDF

Picker_dropdown_proc FRAME hwnd, uMsg, wParam, lParam
	uses ebx,esi,edi
	LOCAL obj		:D
	LOCAL hBmp		:D
	LOCAL hBrush	:D
	LOCAL hPen		:D
	LOCAL memDC		:D
	LOCAL hdc		:D
	LOCAL hImglst	:D
	LOCAL nImages	:D
	LOCAL ps		:PAINTSTRUCT
	LOCAL rect		:RECT
	LOCAL pt		:POINT
	LOCAL nWidth	:D

	.WM_CREATE
	cmp D[uMsg],WM_CREATE
	jne >>.WM_PAINT
		// Since the parent for this window is the desktop
		// we need to store the actual control handle in order
		// to keep track of who it belongs to. This information
		// will allow us to access the  pointers and handles
		// stored in the control as well as send custom messages
		// to the control.
		mov ebx, [lParam]

		invoke SetWindowLong,[hwnd],GWL_DRPDWN_HPARENT,[ebx+CREATESTRUCT.lpCreateParams]

		invoke SetWindowLong,[hwnd],GWL_DRPDWN_CUR_SEL,-1

		// Default selection colour is red
		invoke SetWindowLong,[hwnd],GWL_DRPDWN_SEL_CLR,0FFh

		// Create a bitmap to draw the items on
		invoke GetDC,[ebx+CREATESTRUCT.lpCreateParams]
		mov [hdc],eax
		invoke CreateCompatibleBitmap,[hdc],[ebx+CREATESTRUCT.cx],[ebx+CREATESTRUCT.cy]
		mov [hBmp],eax
		invoke SetWindowLong,[hwnd],GWL_DRPDWN_HPKRBMP,eax

		// Create a compatible DC
		invoke CreateCompatibleDC,[hdc]
		mov [memDC],eax
		invoke ReleaseDC,[ebx+CREATESTRUCT.lpCreateParams],[hdc]

		// Draw the items on the bitmap
		invoke SelectObject,[memDC],[hBmp]
		mov [hBmp],eax

		// Draw the items here
		mov D[rect.left],0
		mov D[rect.top],0
		mov eax,[ebx+CREATESTRUCT.cx]
		mov [rect.right],eax
		mov eax,[ebx+CREATESTRUCT.cy]
		mov [rect.bottom],eax

		// Fill the bitmap with COLOR_BTNFACE
		invoke FillRect,[memDC],offset rect, COLOR_BTNFACE+1

		// Get the handle of this controls image list
		invoke GetWindowLong,[ebx+CREATESTRUCT.lpCreateParams],GWL_PICKER_IMGLIST
		mov [hImglst],eax

		// Get the number of images to draw
		invoke ImageList_GetImageCount,[hImglst]
		mov [nImages],eax
		test eax,eax
		jz >>.ENDDRAW

		// Get the number of images to a row
		invoke GetWindowLong,[ebx+CREATESTRUCT.lpCreateParams],GWL_PICKER_N_WIDTH
		mov [nWidth],eax
		mov ecx,eax

		xor ebx,ebx
		.DRAW
		cmp ebx,[nImages]
		jg >>.ENDDRAW

		// Horizontal
		mov eax,ebx
		mov ecx,[nWidth]
		cdq
		div ecx
		mov edi,eax
		mov eax,edx
		shl edx,4 // 16 pixels
		shl eax,1
		add edx,eax
		mov esi,edx

		// Vertical
		mov eax,edi
		sub edi,1
		shl edi,1
		shl eax,4
		add eax,edi
		add eax,2

		// Draw the image
		invoke ImageList_Draw,[hImglst],ebx,[memDC],esi,eax,ILD_TRANSPARENT
		add ebx,1

		jmp <<.DRAW

		.ENDDRAW

		invoke SelectObject,[memDC],[hBmp]
		mov [hBmp],eax
		invoke DeleteDC,[memDC]

		xor eax,eax
		jmp >>.EXIT

	.WM_PAINT
	cmp D[uMsg],WM_PAINT
	jne >>.WM_CLOSE
		invoke BeginPaint,[hwnd],offset ps
		invoke CreateCompatibleDC,[ps.hdc]
		mov [memDC],eax
		invoke GetClientRect,[hwnd],offset rect
		invoke GetWindowLong,[hwnd],GWL_DRPDWN_HPKRBMP
		invoke SelectObject,[memDC],eax
		mov [obj],eax
		invoke BitBlt,[ps.hdc],0,0,[rect.right],[rect.bottom],[memDC],0,0,SRCCOPY
		
		// Draw a square around the currently selected image
		invoke GetWindowLong,[hwnd],GWL_DRPDWN_CUR_SEL
		test eax,eax
		js >>
			invoke GetStockObject,NULL_BRUSH
			invoke SelectObject,[ps.hdc],eax
			mov [hBrush],eax
			invoke GetWindowLong,[hwnd],GWL_DRPDWN_SEL_CLR
			invoke CreatePen,PS_SOLID,2,eax
			invoke SelectObject,[ps.hdc],eax
			mov [hPen],eax

			invoke GetWindowLong,[hwnd],GWL_DRPDWN_SRCT_TL
			mov ecx,eax
			shr ecx,16
			mov [rect.left],ecx
			and eax,0FFFFh
			mov [rect.top],eax

			invoke GetWindowLong,[hwnd],GWL_DRPDWN_SRCT_BR
			mov ecx,eax
			shr ecx,16
			mov [rect.right],ecx
			and eax,0FFFFh
			mov [rect.bottom],eax

			invoke Rectangle,[ps.hdc],[rect.left],[rect.top],[rect.right],[rect.bottom]
			invoke SelectObject,[ps.hdc],[hBrush]
			invoke SelectObject,[ps.hdc],[hPen]
			invoke DeleteObject,eax
		:
		invoke SelectObject,[memDC],[obj]
		invoke DeleteDC,[memDC]
		invoke EndPaint,[hwnd], offset ps
		xor eax,eax
		jmp >>.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >>.DEFPROC
		invoke GetWindowLong,[hwnd],GWL_DRPDWN_HPKRBMP
		invoke DeleteObject,eax

	.DEFPROC
	invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
	.EXIT
	RET
ENDF

GenerateMask FRAME hbmp,clrMask
	uses edi,esi,ebx
	LOCAL hdc		:D
	LOCAL memdc		:D
	LOCAL memdc2	:D
	LOCAL hilbmp	:D
	LOCAL hmsk		:D
	LOCAL hobj		:D
	LOCAL bminfo	:BITMAP

	// For a mask every bit of the transparent color is matched by a set bit in the mask

	invoke GetObject,[hbmp],SIZEOF BITMAP,offset bminfo
	mov esi,[bminfo.bmWidth]
	mov edi,[bminfo.bmHeight]

	invoke GetDC,NULL
	mov [hdc],eax

	invoke CreateCompatibleDC,[hdc]
	mov [memdc],eax

	invoke CreateCompatibleDC,[hdc]
	mov [memdc2],eax

	invoke CreateBitmap,esi,edi,1,32,NULL
	mov [hmsk],eax

	invoke ReleaseDC,NULL,[hdc]

	// Get the size of the bitmap used for the imagelist
	// A bitmap handle is passed to the function, in order to get the handle for an
	// image list use ImageList_GetImageInfo and pass the IMAGEINFO.hbmImage handle

	invoke SelectObject,[memdc2],[hbmp]
	mov [hilbmp],eax

	invoke SelectObject,[memdc],[hmsk]
	mov [hobj],eax

	// Cycle through the pixels, read the colors and set the corresponding bit in the mask
	mov ebx,esi

	.NEXTROW
		mov esi,ebx
		dec edi
		test edi,edi
		js >>.DONE
		.NEXTPIXEL
			dec esi
			invoke GetPixel,[memdc2],esi,edi
			mov edx,0FFFFFFh
			cmp eax,[clrMask]
			je >
				mov edx,0
			:
			invoke SetPixelV,[memdc],esi,edi,edx
			test esi,esi
			jns <<.NEXTPIXEL
			jmp <<.NEXTROW
	.DONE

	invoke SelectObject,[memdc],[hobj]
	invoke DeleteDC,[memdc]
	invoke SelectObject,[memdc2],[hilbmp]
	invoke DeleteDC,[memdc2]

	// Convert the image to monochrome
	invoke CopyImage,[hmsk],IMAGE_BITMAP,0,0,LR_MONOCHROME
	push eax
	invoke DeleteObject,[hmsk]
	pop eax
	RET
ENDF

